#include "stm8s.h"
#include "iostm003.c"
#include "bitset.c"
#include "stdbool.h"
#include "defines.c"
#include "periph_init.c"
 

extern "C"
{
 INTERRUPT_HANDLER(TIM2_CAPCOM, 14)
 {
  #define btn_pullup PD_DDR_DDR1 = 0
  #define btn_pulldn PD_DDR_DDR1 = 1
  
  static u8 dval = 0xff/4;
  
  btn_pullup;
  
  //timer works
  {
   static u16 tmp;
  
   tmp = TIM2->CCR2H<<8;
   tmp|= TIM2->CCR2L;

   TIM1->EGR = TIM1_EGR_UG;
   TIM2->EGR = TIM2_EGR_UG;    
   TIM1->CR1 |= TIM1_CR1_CEN;
   
   tmp >>= 2;   
   TIM1->ARRH = tmp>>8;
   TIM1->ARRL = (u8)tmp;
   
   tmp = (u32)tmp*dval>>8;
   TIM1->CCR1H = tmp>>8;   
   TIM1->CCR1L = (u8)tmp;
   tmp-=2;
   TIM1->CCR4H = tmp>>8;   
   TIM1->CCR4L = (u8)tmp;   
  }
  //end of timer works
  
  //button works  
  {
   #define lp  3 
   #define lh  50
   #define lr  2   
   #define key PD_IDR_IDR1   
   
   static bool p_trg, on_off=1, dir=1;
   static enum {rls,prs,hold} btn;
   static u8 count[2]; 

   if (!key)
   {
    if(count[0]>lh) 
    {
     btn=hold;
    }
    else if(count[0]>lp)
    {
     btn=prs;
     
     count[0]++;
     count[1]=lr;
    }
    else count[0]++;
   }
   else
   {
    if(count[1])count[1]--; 
    else 
    {
     btn=rls; 
     count[0]=0;
    }
   } 
   
   btn_pulldn;   
 
   static u8 dval_tmp;
   
   if(on_off) 
   {
    TIM1->BKR |= TIM1_BKR_MOE;
    if(dval_tmp>dval)
    {
     if(dval<0xff-2)dval+=2;
     else dval = 0xff; 
    }
    else dval_tmp = 0;
   }
   
   if(btn==rls)
   {
    if(p_trg)
    {
     p_trg=0;     
     if(!(on_off^=1))
     {
      dir=1;
      TIM1->BKR &=~TIM1_BKR_MOE; 
      dval_tmp = dval;
      dval=0x0f;
     }
    }    
   }
   else if(btn==prs)
   {
    p_trg=1;
   }
   else
   {
    p_trg=0;

    static u8 cntdn;
    
    on_off=1;
    
    if(cntdn)cntdn--;
    else if(dir)
    {
     if(dval<0xff-2)dval+=2;
     else 
     {
      dir=0;
      cntdn=50;
      dval=0xff;
     }
    }
    else 
    {
     if(dval>0xff/4)dval-=2;
     else 
     {
      dir=1;
      cntdn=50;
     }
    }
   } 
  }
  //end of button works
  
  PE_ODR^=0xff;
  IWDG_ReloadCounter();
  TIM2->SR1 = 0;
 }
}
void main()
{
 cfg.gpio();
 cfg.clk();
 cfg.t1();
 cfg.t2();
 cfg.iwdg();
 
 asm("rim");
 
 endless asm("wfi");
}
